Debian Bug report logs - #358459
konqueror: doesn't support proper content negotiation

version graph

Package: kdelibs; Maintainer for kdelibs is Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>;

Reported by: Jens Seidel <jensseidel@users.sf.net>

Date: Wed, 22 Mar 2006 20:48:04 UTC

Severity: normal

Tags: fixed-upstream, l10n, patch, upstream

Merged with 401019, 435093, 441204

Found in versions kdelibs/4:3.5.9.dfsg.1-6, kdelibs/4:3.5.10.dfsg.1-1

Done: José Manuel Santamaría Lema <panfaust@gmail.com>

Bug is archived. No further changes may be made.

Forwarded to http://bugs.kde.org/127703

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#358459; Package konqueror. Full text and rfc822 format available.

Acknowledgement sent to Jens Seidel <jensseidel@users.sf.net>:
New Bug report received and forwarded. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Jens Seidel <jensseidel@users.sf.net>
To: submit@bugs.debian.org
Subject: konqueror: doesn't support proper content negotiation
Date: Wed, 22 Mar 2006 21:17:34 +0100
Package: konqueror
Version: 4:3.5.1-1
Severity: normal

Hi,

I noticed that konqueror isn't able to fetch German pages from
www.de.debian.org via content negotiation. Other browsers such as
firebird and lynx work.  Konqueror works well on other mirrors such as
us, nl, fr.

$ HEAD -H "Accept-Language: de" http://www.de.debian.org
contains:
Content-Language: de-lu
Content-Location: index.de.html
Content-Type: text/html

nevertheless I get only English pages.

I selected de_DE locale in controlcenter and also edited
~/.kde/share/config/kio_httprc and set Language=de. No success.

See http://lists.debian.org/debian-www/2006/03/msg00218.html for more
details.

Jens

-- System Information:
Debian Release: testing/unstable
  APT prefers testing
  APT policy: (500, 'testing'), (500, 'stable')
Architecture: i386 (i686)
Shell:  /bin/sh linked to /bin/dash
Kernel: Linux 2.6.12-1-686
Locale: LANG=de_DE.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)

Versions of packages konqueror depends on:
ii  kcontrol                  4:3.5.1-1      control center for KDE
ii  kdebase-kio-plugins       4:3.5.1-1      core I/O slaves for KDE
ii  kdelibs4c2a               4:3.5.1-2      core libraries for all KDE applica
ii  kdesktop                  4:3.5.1-1      miscellaneous binaries and files f
ii  kfind                     4:3.5.1-1      file-find utility for KDE
ii  libacl1                   2.2.35-1       Access control list shared library
ii  libart-2.0-2              2.3.17-1       Library of functions for 2D graphi
ii  libattr1                  2.4.25-1       Extended attribute shared library
ii  libaudio2                 1.7-5          The Network Audio System (NAS). (s
ii  libc6                     2.3.5-13       GNU C Library: Shared libraries an
ii  libfam0                   2.7.0-9        Client library to control the FAM 
ii  libfontconfig1            2.3.2-1.1      generic font configuration library
ii  libfreetype6              2.1.10-1       FreeType 2 font engine, shared lib
ii  libgcc1                   1:4.0.3-1      GCC support library
ii  libice6                   6.9.0.dfsg.1-4 Inter-Client Exchange library
ii  libidn11                  0.5.18-2       GNU libidn library, implementation
ii  libjpeg62                 6b-12          The Independent JPEG Group's JPEG 
ii  libkonq4                  4:3.5.1-1      core libraries for Konqueror
ii  libpng12-0                1.2.8rel-5     PNG library - runtime
ii  libqt3-mt                 3:3.3.5-4      Qt GUI Library (Threaded runtime v
ii  libsm6                    6.9.0.dfsg.1-4 X Window System Session Management
ii  libstdc++6                4.0.3-1        The GNU Standard C++ Library v3
ii  libx11-6                  6.9.0.dfsg.1-4 X Window System protocol client li
ii  libxcursor1               1.1.3-1        X cursor management library
ii  libxext6                  6.9.0.dfsg.1-4 X Window System miscellaneous exte
ii  libxft2                   2.1.8.2-3      FreeType-based font drawing librar
ii  libxi6                    6.9.0.dfsg.1-4 X Window System Input extension li
ii  libxinerama1              6.9.0.dfsg.1-4 X Window System multi-head display
ii  libxrandr2                6.9.0.dfsg.1-4 X Window System Resize, Rotate and
ii  libxrender1               1:0.9.0.2-1    X Rendering Extension client libra
ii  libxt6                    6.9.0.dfsg.1-4 X Toolkit Intrinsics
ii  zlib1g                    1:1.2.3-9      compression library - runtime

konqueror recommends no packages.

-- no debconf information



Noted your statement that Bug has been forwarded to http://bugs.kde.org/127703. Request was from Pierre Habouzit <madcoder@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#358459; Package konqueror. Full text and rfc822 format available.

Acknowledgement sent to Jens Seidel <jensseidel@users.sf.net>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. Full text and rfc822 format available.

Message #12 received at 358459@bugs.debian.org (full text, mbox):

From: Jens Seidel <jensseidel@users.sf.net>
To: debian-www@lists.debian.org, 358459@bugs.debian.org
Cc: Sylvain Sauvage <Sylvain.Sauvage@metanoesis.net>
Subject: Re: Language negotiation problem
Date: Sat, 2 Sep 2006 15:54:28 +0200
On Sat, Sep 02, 2006 at 01:59:13AM +0200, Sylvain Sauvage wrote:
> Samedi 2 septembre 2006, 00:49:51 CEST, Jens Seidel a écrit :
> > On Sat, Sep 02, 2006 at 12:08:56AM +0200, Sylvain Sauvage wrote:
> I know it worked with Firefox but as it didn't worked with Konqueror (and
> a message was posted on debian-user-french about problems with Epiphany),
> 
> I meant with Konqueror:
> it, es -> Italian
> it, en -> English
> fr, en -> English
> es, fr -> French
> 
> Why not always the last one, or the first one, or English?
> 
> > > Sometimes I get the first listed language, sometimes English, or the
> > > last one...
> > > Maybe I'm wrong, but it seems www.debian.org does something wrong,
> > > doesn't it ?
> > 
> > Please a different server, such as www.de.debian.org. Can you still
> > reproduce it?
> 
> With Konqueror yes. Firefox is OK.
> Setting Languages=fr-fr,fr;q=0.8,en-us;q=0.5,en;q=0.3 in kio_httprc
> solves the problem on www.{it,fr,jp,de,}.debian.org (and others, I
> guess ;o).

Yep, for me too. Does this mean the problem is fixed now for everyone
and every server? I will update
http://www.de.debian.org/intro/cn#konqueror to reflect this.

I still get English pages without a Languages= line at all. But I think
KDE should deliver the single default language in this case. Only if
multiple languages are requested ~/.kde/share/config/kio_httprc needs to
be modified!?

> Oh, about the bug report you pointed: the poster says he has only
> problems with w.de.d.o, not others. Aren't all sites exact mirrors?

The poster is me :-)

In the past I was able to reproduce it only with the German mirror,
later I noticed the problem also in other mirrors and now it vanished!?

I assumed it also depends on the web server which the Debian project
cannot dictate on mirrors.

Can other users please test konqueror?

Jens



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#358459; Package konqueror. Full text and rfc822 format available.

Message #15 received at 358459@bugs.debian.org (full text, mbox):

From: Sylvain Sauvage <Sylvain.Sauvage@metanoesis.net>
To: debian-www@lists.debian.org
Subject: Re: Language negotiation problem
Date: Sat, 2 Sep 2006 17:02:22 +0200
Samedi 2 septembre 2006, 15:54:28 CEST, Jens Seidel a écrit :
>[...] 
> I still get English pages without a Languages= line at all.

Without Languages= line in kio_httprc, Konqueror sends
"AcceptLanguage=fr, en" (it must be: "<current locale>, en").

> But I think
> KDE should deliver the single default language in this case. Only if
> multiple languages are requested ~/.kde/share/config/kio_httprc needs to
> be modified!?

If it instists to send "en", it should at least send a rating, for
instance "fr, en;q=0.5"?

> > Oh, about the bug report you pointed: the poster says he has only
> > problems with w.de.d.o, not others. Aren't all sites exact mirrors?
> 
> The poster is me :-)

Ah. I said I should have gone to bed earlier ;o)

> In the past I was able to reproduce it only with the German mirror,
> later I noticed the problem also in other mirrors and now it vanished!?

Hmmm. Mirroring propagation time?

> I assumed it also depends on the web server which the Debian project
> cannot dictate on mirrors.

Does anyone know (for sure) a web site doing the same language
negotiation as w.d.o?

> Can other users please test konqueror?

-- 
 Sylvain Sauvage




Forcibly Merged 358459 401019. Request was from Olivier Trichet <nive@nivalis.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#358459; Package konqueror. Full text and rfc822 format available.

Acknowledgement sent to Tomasz Chmielewski <mangoo@wpkg.org>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. Full text and rfc822 format available.

Message #22 received at 358459@bugs.debian.org (full text, mbox):

From: Tomasz Chmielewski <mangoo@wpkg.org>
To: 358459@bugs.debian.org
Subject: Re: konqueror: doesn't support proper content negotiation
Date: Tue, 22 Apr 2008 13:32:38 +0200
It looks it doesn't happen with the default installation in Etch + 
updates any more?


Tomasz Chmielewski
http://wpkg.org




Forcibly Merged 358459 401019 435093 441204. Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Wed, 02 Jul 2008 09:48:01 GMT) Full text and rfc822 format available.

Bug reopened, originator not changed. Request was from Jens Seidel <jensseidel@users.sf.net> to control@bugs.debian.org. (Mon, 08 Sep 2008 14:36:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#358459; Package konqueror. (Thu, 09 Oct 2008 15:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Didier Raboud <didier@raboud.com>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. (Thu, 09 Oct 2008 15:03:02 GMT) Full text and rfc822 format available.

Message #31 received at 358459@bugs.debian.org (full text, mbox):

From: Didier Raboud <didier@raboud.com>
To: 358459@bugs.debian.org
Cc: debian-www@lists.debian.org
Subject: Bug 358459: The problem could be solved on Debian's side
Date: Thu, 9 Oct 2008 16:55:39 +0200
[Message part 1 (text/plain, inline)]
Hi, 

I think that the problem can be solved on Debian's side.

My actual konqueror (3.5.9.dfsg.1-5) sends "Accept-Language: fr,en", which, 
according to RFC2616 (HTTP1.1) [0], means that both french and english are 
_equally_ acceptable (Section 14.4) :

"If an Accept-Language header is present, then all languages which are 
assigned a quality factor greater than 0 are acceptable."

But debian.org answers weirdly :

HEAD -H "Accept-Language: %1,%2" http://www.debian.org

=>

%1	%2	 Answer
fr	de	 fr
de	fr	 fr
fr	en	 en-gb
en	fr	 en-gb
fr	en;q=0.5 fr
de	-	 de

It seems that there is sort of an internal priority list (en > fr > de) (which 
is OK, regarding the RFC).

My proposal is to render the correct language page according to the user's 
priority list (ordered list), instead of the server's.

But konqueror still has to be fixed to give a lower priority to english...

Regards, 

OdyX

[0] http://tools.ietf.org/html/rfc2616
-- 
Didier Raboud, proud Debian user.
CH-1802 Corseaux
didier@raboud.com
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#358459; Package konqueror. (Thu, 09 Oct 2008 19:09:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Franklin PIAT <fpiat@klabs.be>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. (Thu, 09 Oct 2008 19:09:11 GMT) Full text and rfc822 format available.

Message #36 received at 358459@bugs.debian.org (full text, mbox):

From: Franklin PIAT <fpiat@klabs.be>
To: Didier Raboud <didier@raboud.com>
Cc: 358459@bugs.debian.org, debian-www@lists.debian.org
Subject: Re: Bug 358459: The problem could be solved on Debian's side
Date: Thu, 09 Oct 2008 21:07:37 +0200
On Thu, 2008-10-09 at 16:55 +0200, Didier Raboud wrote:
> My actual konqueror (3.5.9.dfsg.1-5) sends "Accept-Language: fr,en", which, 
> according to RFC2616 (HTTP1.1) [0], means that both french and english are 
> _equally_ acceptable (Section 14.4) :
[..]
> My proposal is to render the correct language page according to the user's 
> priority list (ordered list), instead of the server's.

If the web server were to render page according to the list order, it
would mean that it doesn't consider them "equally acceptable".

The way I understand the specs is that if a user states that two
languages are "equally acceptable", then it means that it's up to the
server to negotiate, based on it's own criteria.

The RFC2616 "12.1 Server-driven Negotiation" says :
> However, an origin server is not limited to these dimensions and MAY
> vary the response based on any aspect of the request, including
> information outside the request-header fields or within extension
> header fields not defined by this specification.

And that's very useful for server side negotiation, because on the
server side, it's likely that the language were written in one given
language, then translated. It would then be sensible to provide the
original document.

Thanks for the suggestion anyway (and Keep reporting bugs).

Franklin





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#358459; Package konqueror. (Thu, 09 Oct 2008 21:12:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Didier Raboud <didier@raboud.com>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. (Thu, 09 Oct 2008 21:12:05 GMT) Full text and rfc822 format available.

Message #41 received at 358459@bugs.debian.org (full text, mbox):

From: Didier Raboud <didier@raboud.com>
To: Franklin PIAT <fpiat@klabs.be>
Cc: 358459@bugs.debian.org, debian-www@lists.debian.org
Subject: Re: Bug 358459: The problem could be solved on Debian's side
Date: Thu, 9 Oct 2008 23:09:00 +0200
[Message part 1 (text/plain, inline)]
Le jeudi 9 octobre 2008 21:07:37 Franklin PIAT, vous avez écrit :
> On Thu, 2008-10-09 at 16:55 +0200, Didier Raboud wrote:
> > My actual konqueror (3.5.9.dfsg.1-5) sends "Accept-Language: fr,en",
> > which, according to RFC2616 (HTTP1.1) [0], means that both french and
> > english are _equally_ acceptable (Section 14.4) :
>
> [..]
>
> > My proposal is to render the correct language page according to the
> > user's priority list (ordered list), instead of the server's.
>
> If the web server were to render page according to the list order, it
> would mean that it doesn't consider them "equally acceptable".
>
> The way I understand the specs is that if a user states that two
> languages are "equally acceptable", then it means that it's up to the
> server to negotiate, based on it's own criteria.

The problem in this case is that it's not the _user_ who is stating its 
priorities, but the software he uses...

> The RFC2616 "12.1 Server-driven Negotiation" says :
> > However, an origin server is not limited to these dimensions and MAY
> > vary the response based on any aspect of the request, including
> > information outside the request-header fields or within extension
> > header fields not defined by this specification.
>
> And that's very useful for server side negotiation, because on the
> server side, it's likely that the language were written in one given
> language, then translated. It would then be sensible to provide the
> original document.
>
> Thanks for the suggestion anyway (and Keep reporting bugs).
>
> Franklin

Many thanks for your detailed explanation. My more immediate concern is that 
for a very long time now, konqueror users are still shown an english Debian 
homepage, which is really annoying.

I'll _maybe_ try to find time to go through the konqueror sources and try to 
find where a simple patch could apply to correct this annoying behavior. 
Let's hope I'll find time ! ;)

Don't worry : I won't stop reporting and contributing for and on bugs : what 
lacks is time and knowledge, not motivation ;) .

Best regards, 

OdyX
-- 
Didier Raboud, proud Debian user.
CH-1802 Corseaux
didier@raboud.com
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>:
Bug#358459; Package konqueror. (Mon, 13 Oct 2008 16:24:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Didier Raboud <didier@raboud.com>:
Extra info received and forwarded to list. Copy sent to Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>. (Mon, 13 Oct 2008 16:24:02 GMT) Full text and rfc822 format available.

Message #46 received at 358459@bugs.debian.org (full text, mbox):

From: Didier Raboud <didier@raboud.com>
To: Franklin PIAT <fpiat@klabs.be>
Cc: 358459@bugs.debian.org, debian-www@lists.debian.org, control@bugs.debian.org
Subject: Bug 358459: Simple patch (was: The problem could be solved on Debian's side)
Date: Mon, 13 Oct 2008 18:22:56 +0200
[Message part 1 (text/plain, inline)]
tags 358459 patch
tags 358459 upstream
reassign 358459 kdelibs 4:3.5.9.dfsg.1-6
thanks

Hi,

I finally took some professional time (...) to analyse this bug. The result of 
these two hours is the attached patch.

The idea is to simply add ";q=0.1" (exact value to be discussed maybe) at the 
end of the "Accept-Language" header. With this patch, the "default" language 
(always "en") is given a lower priority. Note that the patch is to be applied 
on kdelibs (3.5.9.dfsg.1) and not on kdebase.

It is no perfect solution, but at least provides a way to read debian.org 
translated !

Best regards, 

OdyX
-- 
Didier Raboud, proud Debian user.
CH-1802 Corseaux
didier@raboud.com
[kdelibs-AcceptLanguage.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Tags added: patch Request was from Didier Raboud <didier@raboud.com> to control@bugs.debian.org. (Mon, 13 Oct 2008 16:24:03 GMT) Full text and rfc822 format available.

Tags added: upstream Request was from Didier Raboud <didier@raboud.com> to control@bugs.debian.org. (Mon, 13 Oct 2008 16:24:05 GMT) Full text and rfc822 format available.

Bug reassigned from package `konqueror' to `kdelibs'. Request was from Didier Raboud <didier@raboud.com> to control@bugs.debian.org. (Mon, 13 Oct 2008 16:24:07 GMT) Full text and rfc822 format available.

Bug marked as found in version 4:3.5.10.dfsg.1-1. Request was from Didier Raboud <didier@raboud.com> to control@bugs.debian.org. (Mon, 27 Oct 2008 13:03:06 GMT) Full text and rfc822 format available.

Added tag(s) fixed-upstream. Request was from bts-link-upstream@lists.alioth.debian.org to control@bugs.debian.org. (Thu, 01 Dec 2011 23:18:12 GMT) Full text and rfc822 format available.

Reply sent to José Manuel Santamaría Lema <panfaust@gmail.com>:
You have taken responsibility. (Fri, 02 Dec 2011 15:27:04 GMT) Full text and rfc822 format available.

Notification sent to Jens Seidel <jensseidel@users.sf.net>:
Bug acknowledged by developer. (Fri, 02 Dec 2011 15:27:06 GMT) Full text and rfc822 format available.

Message #61 received at 358459-done@bugs.debian.org (full text, mbox):

From: José Manuel Santamaría Lema <panfaust@gmail.com>
To: 358459-done@bugs.debian.org
Subject: Closing bug
Date: Fri, 2 Dec 2011 16:22:47 +0100
According to this comment in the upstream bug report, this bug is fixed:
http://bugs.kde.org/show_bug.cgi?id=127703#c11




Reply sent to José Manuel Santamaría Lema <panfaust@gmail.com>:
You have taken responsibility. (Fri, 02 Dec 2011 15:27:09 GMT) Full text and rfc822 format available.

Notification sent to Hans <hans.ullrich@loop.de>:
Bug acknowledged by developer. (Fri, 02 Dec 2011 15:27:09 GMT) Full text and rfc822 format available.

Reply sent to José Manuel Santamaría Lema <panfaust@gmail.com>:
You have taken responsibility. (Fri, 02 Dec 2011 15:27:12 GMT) Full text and rfc822 format available.

Notification sent to Hans <hans.ullrich@loop.de>:
Bug acknowledged by developer. (Fri, 02 Dec 2011 15:27:13 GMT) Full text and rfc822 format available.

Reply sent to José Manuel Santamaría Lema <panfaust@gmail.com>:
You have taken responsibility. (Fri, 02 Dec 2011 15:27:15 GMT) Full text and rfc822 format available.

Notification sent to Wojciech Zareba <wojtekz@comp.waw.pl>:
Bug acknowledged by developer. (Fri, 02 Dec 2011 15:27:16 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 31 Dec 2011 07:32:23 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 15:23:31 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.